﻿Shader "DepthWaterShader" {
Properties {
    _Color ("Main Color", Color) = (1,1,1,1)
    _SpecColor ("Specular Color", Color) = (0.5, 0.5, 0.5, 0)
    _Shininess ("Shininess", Range (0.01, 1)) = 0.078125
    _MainTex ("Base (RGB) TransGloss (A)", 2D) = "white" {}
//  _Perturb ("Perturb", 2D) = "black" {}
    _Mask ("Mask", 2D) = "black" {}
    _BumpMap ("Normal map", 2D) = "bump" {}
    _BumpMap2 ("Normal map2", 2D) = "bump" {}
     
}
 
SubShader {
    Tags {"Queue"="Transparent" "IgnoreProjector"="True" "RenderType"="Transparent"}
    LOD 300
 
CGPROGRAM
#pragma surface surf BlinnPhong alpha vertex:vert
 
 
sampler2D _MainTex;
sampler2D _Mask;
//sampler2D _Perturb;
sampler2D _BumpMap;
sampler2D _BumpMap2;
fixed4 _Color;
half _Shininess;
 
struct Input {
    float2 uv_MainTex;
    float2 uv_Mask;
    //float3 worldPos;
};
 
 void vert (inout appdata_full v) 
 {
    v.vertex.z += (_SinTime.y*0.5f-0.5f)*10;
 }
 
void surf (Input IN, inout SurfaceOutput o) {
    fixed4 tex = tex2D(_MainTex, IN.uv_MainTex);
     
    float2 pan = float2(0,(_SinTime.y*0.5f-0.5f));
     
    fixed4 norm1 = tex2D(_BumpMap, IN.uv_MainTex+pan*0.2f);
    fixed4 norm2 = tex2D(_BumpMap2, IN.uv_MainTex+pan*0.22f);
     
     
     
    fixed water = tex2D(_Mask, IN.uv_Mask).a;
     
    o.Albedo = tex.rgb * _Color.rgb;
    o.Gloss = tex.a;
    o.Alpha = ((1-_SinTime.y)*(tex.a*2 * _Color.a))-(1-water);
    o.Specular = tex.r*_Shininess;
    o.Normal = UnpackNormal(lerp(norm1,norm2,tex.r));
}
ENDCG
}
 
Fallback "Transparent/VertexLit"
}